//---------------------------------------------------------------------------
// yqέp    by dllee<dllee@edirect168.com> http://dllee.ktop.com.tw
// <2003-07-20>
// ѦҸ
// http://msdn.microsoft.com/library/default.asp?url=/library/en-us/iphlp/iphlp/getiftable.asp
// http://msdn.microsoft.com/library/default.asp?url=/library/en-us/rras/rras/mib_iftable.asp
// http://msdn.microsoft.com/library/default.asp?url=/library/en-us/rras/rras/mib_ifrow.asp
//
// yqέp    by dllee<dllee@edirect168.com> http://dllee.ktop.com.tw
// <2003-07-22> Add a Maximum Values for all net interface I/O
// <2003-07-22> Add Auto Maximum Scale Down Feature
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "iphlpapi.h"
#include "Unit1.h"

#define _MAX_SCALEDOWN_COUNT_ 10
#define _MAX_TABLE_ 8
typedef struct _MIB_IFTABLE8 {
  DWORD dwNumEntries;
  MIB_IFROW table[_MAX_TABLE_];
} MIB_IFTABLE8, *PMIB_IFTABLE8;

//----------------------------------------------------------------------------//
#pragma package(smart_init)
#pragma resource "*.dfm"

TForm1 *Form1;
//----------------------------------------------------------------------------//
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  List[0]=new TListBox(TabSheet1);
  List[0]->Parent=TabSheet1;
  List[0]->Align=alClient;
  List[0]->Name="ListBox1";
  List[1]=new TListBox(TabSheet2);
  List[1]->Parent=TabSheet2;
  List[1]->Align=alClient;
  List[1]->Name="ListBox2";
  List[2]=new TListBox(TabSheet3);
  List[2]->Parent=TabSheet3;
  List[2]->Align=alClient;
  List[2]->Name="ListBox3";
  List[3]=new TListBox(TabSheet4);
  List[3]->Parent=TabSheet4;
  List[3]->Align=alClient;
  List[3]->Name="ListBox4";
  List[4]=new TListBox(TabSheet5);
  List[4]->Parent=TabSheet5;
  List[4]->Align=alClient;
  List[4]->Name="ListBox5";
  List[5]=new TListBox(TabSheet6);
  List[5]->Parent=TabSheet6;
  List[5]->Align=alClient;
  List[5]->Name="ListBox6";
  List[6]=new TListBox(TabSheet7);
  List[6]->Parent=TabSheet7;
  List[6]->Align=alClient;
  List[6]->Name="ListBox7";
  List[7]=new TListBox(TabSheet8);
  List[7]->Parent=TabSheet8;
  List[7]->Align=alClient;
  List[7]->Name="ListBox8";

  Tab[0]=TabSheet1;
  Tab[1]=TabSheet2;
  Tab[2]=TabSheet3;
  Tab[3]=TabSheet4;
  Tab[4]=TabSheet5;
  Tab[5]=TabSheet6;
  Tab[6]=TabSheet7;
  Tab[7]=TabSheet8;

  memset(IOdata, 0, sizeof(NETIO)*8);
  memset(&MAXdata, 0, sizeof(NETIO));
  Button1Click(Button1);
}
//----------------------------------------------------------------------------//

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  static int iCount=0;
  MIB_IFTABLE8 MIB;
  DWORD Size=sizeof(MIB);
  DWORD Result=GetIfTable((_MIB_IFTABLE*)&MIB,&Size,CheckBox1->Checked);
  if(Result==ERROR_INSUFFICIENT_BUFFER)
  {
    MIB.dwNumEntries=_MAX_TABLE_;
    Result=NO_ERROR;
  }
  if(Result==NO_ERROR)
  {
    ListBox->Items->BeginUpdate();
    ListBox->Clear();

    MAXdata.dwInOctetsPerSec=0;
    MAXdata.dwOutOctetsPerSec=0;
    MAXdata.dwMaxInOctetsPerSec=0;
    MAXdata.dwMaxOutOctetsPerSec=0;

    int i;
    for(i=0;i<MIB.dwNumEntries;i++)
    {
      List[i]->Items->BeginUpdate();
      List[i]->Clear();
      Tab[i]->TabVisible=true;
      // List[i]->Items->Add("Name = "+String(WideString((wchar_t*)MIB.table[i].wszName)));
      // List[i]->Items->Add("PhysAddrLen = "+String(MIB.table[i].dwPhysAddrLen));
      AnsiString asMAC=EmptyStr;
      for(int j=0;j<MIB.table[i].dwPhysAddrLen;j++)
        asMAC.cat_printf("%02X:",MIB.table[i].bPhysAddr[j]);
      asMAC.SetLength(asMAC.Length()-1);
      List[i]->Items->Add("PhysAddr = "+asMAC);

      // List[i]->Items->Add("DescrLen = "+String(MIB.table[i].dwDescrLen));
      asMAC=String((char*)MIB.table[i].bDescr);
      List[i]->Items->Add("Descr = "+asMAC.SetLength(MIB.table[i].dwDescrLen));

      List[i]->Items->Add("Index = "+String(MIB.table[i].dwIndex));
      List[i]->Items->Add("Type = "+String(MIB.table[i].dwType));
      List[i]->Items->Add("Mtu = "+String(MIB.table[i].dwMtu));
      List[i]->Items->Add("Speed = "+String(MIB.table[i].dwSpeed));
      List[i]->Items->Add("AdminStatus = "+String(MIB.table[i].dwAdminStatus));
      List[i]->Items->Add("OperStatus = "+String(MIB.table[i].dwOperStatus));
      List[i]->Items->Add("LastChange = "+String(MIB.table[i].dwLastChange));
      List[i]->Items->Add("InOctets = "+String(MIB.table[i].dwInOctets));
      List[i]->Items->Add("InUcastPkts = "+String(MIB.table[i].dwInUcastPkts));
      List[i]->Items->Add("InNUcastPkts = "+String(MIB.table[i].dwInNUcastPkts));
      List[i]->Items->Add("InDiscards = "+String(MIB.table[i].dwInDiscards));
      List[i]->Items->Add("InErrors = "+String(MIB.table[i].dwInErrors));
      List[i]->Items->Add("InUnknownProtos = "+String(MIB.table[i].dwInUnknownProtos));
      List[i]->Items->Add("OutOctets = "+String(MIB.table[i].dwOutOctets));
      List[i]->Items->Add("OutUcastPkts = "+String(MIB.table[i].dwOutUcastPkts));
      List[i]->Items->Add("OutNUcastPkts = "+String(MIB.table[i].dwOutNUcastPkts));
      List[i]->Items->Add("OutDiscards = "+String(MIB.table[i].dwOutDiscards));
      List[i]->Items->Add("OutErrors = "+String(MIB.table[i].dwOutErrors));
      List[i]->Items->Add("OutQLen = "+String(MIB.table[i].dwOutQLen));

      IOdata[i].dwInOctetsPerSec=MIB.table[i].dwInOctets-IOdata[i].dwLastInOctets;
      if(IOdata[i].dwLastInOctets!=0 && IOdata[i].dwMaxInOctetsPerSec < IOdata[i].dwInOctetsPerSec)
        IOdata[i].dwMaxInOctetsPerSec=IOdata[i].dwInOctetsPerSec;
      IOdata[i].dwLastInOctets=MIB.table[i].dwInOctets;

      IOdata[i].dwOutOctetsPerSec=MIB.table[i].dwOutOctets-IOdata[i].dwLastOutOctets;
      if(IOdata[i].dwLastOutOctets!=0 && IOdata[i].dwMaxOutOctetsPerSec < IOdata[i].dwOutOctetsPerSec)
        IOdata[i].dwMaxOutOctetsPerSec=IOdata[i].dwOutOctetsPerSec;
      IOdata[i].dwLastOutOctets=MIB.table[i].dwOutOctets;

      // Auto Scale down the Maximum Value
      if(IOdata[i].dwInOctetsPerSec != 0 || IOdata[i].dwOutOctetsPerSec != 0 )
        IOdata[i].dwZeroCount=0;
      else
      {
        if(++IOdata[i].dwZeroCount > _MAX_SCALEDOWN_COUNT_)
        {
          IOdata[i].dwZeroCount=0;
          IOdata[i].dwMaxOutOctetsPerSec >>= 1;
          IOdata[i].dwMaxInOctetsPerSec >>= 1;
        }
      }

      List[i]->Items->Add("");
      List[i]->Items->Add("-----");
      List[i]->Items->Add("");
      List[i]->Items->Add("InOctetsPerSec = "+String(IOdata[i].dwInOctetsPerSec));
      List[i]->Items->Add("OutOctetsPerSec = "+String(IOdata[i].dwOutOctetsPerSec));
      // List[i]->Items->Add("LastInOctets = "+String(IOdata[i].dwLastInOctets));
      // List[i]->Items->Add("LastOutOctets = "+String(IOdata[i].dwLastOutOctets));
      List[i]->Items->Add("MaxInOctetsPerSec = "+String(IOdata[i].dwMaxInOctetsPerSec));
      List[i]->Items->Add("MaxOutOctetsPerSec = "+String(IOdata[i].dwMaxOutOctetsPerSec));

      ListBox->Items->Add("Descr = "+asMAC.SetLength(MIB.table[i].dwDescrLen));
      ListBox->Items->Add("InOctetsPerSec = "+String(IOdata[i].dwInOctetsPerSec));
      ListBox->Items->Add("OutOctetsPerSec = "+String(IOdata[i].dwOutOctetsPerSec));
      ListBox->Items->Add("MaxInOctetsPerSec = "+String(IOdata[i].dwMaxInOctetsPerSec));
      ListBox->Items->Add("MaxOutOctetsPerSec = "+String(IOdata[i].dwMaxOutOctetsPerSec));
      ListBox->Items->Add("");

      if(IOdata[i].dwInOctetsPerSec > MAXdata.dwInOctetsPerSec)
        MAXdata.dwInOctetsPerSec = IOdata[i].dwInOctetsPerSec;
      if(IOdata[i].dwOutOctetsPerSec > MAXdata.dwOutOctetsPerSec)
        MAXdata.dwOutOctetsPerSec = IOdata[i].dwOutOctetsPerSec;
      if(IOdata[i].dwMaxInOctetsPerSec > MAXdata.dwMaxInOctetsPerSec)
        MAXdata.dwMaxInOctetsPerSec = IOdata[i].dwMaxInOctetsPerSec;
      if(IOdata[i].dwMaxOutOctetsPerSec > MAXdata.dwMaxOutOctetsPerSec)
        MAXdata.dwMaxOutOctetsPerSec = IOdata[i].dwMaxOutOctetsPerSec;

      List[i]->Items->EndUpdate();
    }

    for(;i<_MAX_TABLE_;i++)
    {
      List[i]->Clear();
      Tab[i]->TabVisible=false;
      List[i]->Items->Add("--");
    }

    ListBox->Items->Add("Descr = Maximum data of all net interfaces");
    ListBox->Items->Add("Max InOctetsPerSec = "+String(MAXdata.dwInOctetsPerSec));
    ListBox->Items->Add("Max OutOctetsPerSec = "+String(MAXdata.dwOutOctetsPerSec));
    ListBox->Items->Add("Max MaxInOctetsPerSec = "+String(MAXdata.dwMaxInOctetsPerSec));
    ListBox->Items->Add("Max MaxOutOctetsPerSec = "+String(MAXdata.dwMaxOutOctetsPerSec));
    ListBox->Items->EndUpdate();
  }
  else
  {
    ShowMessage("Sorry Your System Do Not Support...");
  }
}
//----------------------------------------------------------------------------//

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  Button1Click(Button1);
}
//----------------------------------------------------------------------------//
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  Close();
}
//----------------------------------------------------------------------------//
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
  Button1Click(Button1);
  Button3Click(Button3);
}
//----------------------------------------------------------------------------//

void __fastcall TForm1::Button3Click(TObject *Sender)
{
    for(int i=0;i<_MAX_TABLE_;i++)
    {
      IOdata[i].dwMaxInOctetsPerSec=0;
      IOdata[i].dwMaxOutOctetsPerSec=0;
    }
    MAXdata.dwMaxInOctetsPerSec=0;
    MAXdata.dwMaxOutOctetsPerSec=0;
}
//----------------------------------------------------------------------------//
/*-----------------------------------------------------------------------------
// Iprtrmib.h
typedef struct _MIB_IFROW {
  WCHAR wszName[MAX_INTERFACE_NAME_LEN];
  DWORD dwIndex;
  DWORD dwType;
  DWORD dwMtu;
  DWORD dwSpeed;
  DWORD dwPhysAddrLen;
  BYTE  bPhysAddr[MAXLEN_PHYSADDR];
  DWORD dwAdminStatus;
  DWORD dwOperStatus;
  DWORD dwLastChange;
  DWORD dwInOctets;
  DWORD dwInUcastPkts;
  DWORD dwInNUcastPkts;
  DWORD dwInDiscards;
  DWORD dwInErrors;
  DWORD dwInUnknownProtos;
  DWORD dwOutOctets;
  DWORD dwOutUcastPkts;
  DWORD dwOutNUcastPkts;
  DWORD dwOutDiscards;
  DWORD dwOutErrors;
  DWORD dwOutQLen;
  DWORD dwDescrLen;
  BYTE  bDescr[MAXLEN_IFDESCR];
} MIB_IFROW, *PMIB_IFROW;
Members
wszName
Pointer to a Unicode string that contains the name of the interface.
dwIndex
Specifies the index that identifies the interface.
dwType
Specifies the type of interface.
This member can be one of the following values.

MIB_IF_TYPE_OTHER
MIB_IF_TYPE_ETHERNET
MIB_IF_TYPE_TOKENRING
MIB_IF_TYPE_FDDI
MIB_IF_TYPE_PPP
MIB_IF_TYPE_LOOPBACK
MIB_IF_TYPE_SLIP

dwMtu 
Specifies the Maximum Transmission Unit (MTU). 
dwSpeed 
Specifies the speed of the interface in bits per second.
dwPhysAddrLen
Specifies the length of the physical address specified by the bPhysAddr member. 
bPhysAddr 
Specifies the physical address of the adapter for this interface. 
dwAdminStatus 
Specifies the interface is administratively enabled or disabled. 
dwOperStatus 
Specifies the operational status of the interface. This member can be one of the following values. Value Meaning
MIB_IF_OPER_STATUS_NON_OPERATIONAL LAN adapter has been disabled, for example because of an address conflict. 
MIB_IF_OPER_STATUS_UNREACHABLE WAN adapter that is not connected.
MIB_IF_OPER_STATUS_DISCONNECTED For LAN adapters: network cable disconnected. For WAN adapters: no carrier.
MIB_IF_OPER_STATUS_CONNECTING WAN adapter that is in the process of connecting. 
MIB_IF_OPER_STATUS_CONNECTED WAN adapter that is connected to a remote peer. 
MIB_IF_OPER_STATUS_OPERATIONAL Default status for LAN adapters 

dwLastChange
Specifies the last time the operational status changed.
dwInOctets 
Specifies the number of octets of data received through this interface. 
dwInUcastPkts 
Specifies the number of unicast packets received through this interface. 
dwInNUcastPkts 
Specifies the number of non-unicast packets received through this interface. Broadcast and multicast packets are included. 
dwInDiscards 
Specifies the number of incoming packets that were discarded even though they did not have errors. 
dwInErrors
Specifies the number of incoming packets that were discarded because of errors.
dwInUnknownProtos 
Specifies the number of incoming packets that were discarded because the protocol was unknown.
dwOutOctets 
Specifies the number of octets of data sent through this interface. 
dwOutUcastPkts
Specifies the number of unicast packets sent through this interface.
dwOutNUcastPkts 
Specifies the number of non-unicast packets sent through this interface. Broadcast and multicast packets are included. 
dwOutDiscards 
Specifies the number of outgoing packets that were discarded even though they did not have errors. 
dwOutErrors 
Specifies the number of outgoing packets that were discarded because of errors. 
dwOutQLen 
Specifies the output queue length. 
dwDescrLen
Specifies the length of the bDescr member.
bDescr 
Contains a description of the interface.

typedef struct _MIB_IFTABLE {
  DWORD dwNumEntries;
  MIB_IFROW table[ANY_SIZE];
} MIB_IFTABLE, *PMIB_IFTABLE;

// Iphlpapi.h
DWORD GetIfTable(
  PMIB_IFTABLE pIfTable,
  PULONG pdwSize,
  BOOL bOrder
);
-----------------------------------------------------------------------------*/

